diff -Naur color-theme-6.6.0/color-theme.el color-theme-6.6.0.patched//color-theme.el
--- color-theme-6.6.0/color-theme.el	2006-05-28 14:07:29.000000000 +0100
+++ color-theme-6.6.0.patched//color-theme.el	2010-12-01 23:00:32.000000000 +0000
@@ -1662,6 +1662,12 @@
 ;; define-color-theme is around, it should be easy to change in just the
 ;; one place. 
 
+(defmacro when-color-theme-is-global (prop)
+  "Return prop when color-theme-is-global is true.
+
+   Use to wrap alist settings that should not be made buffer local,
+such as widget-mouse-face and possibly others."
+  (when color-theme-is-global prop))
 
 (provide 'color-theme)
 
diff -Naur color-theme-6.6.0/themes/color-theme-library.el color-theme-6.6.0.patched//themes/color-theme-library.el
--- color-theme-6.6.0/themes/color-theme-library.el	2006-05-28 13:53:17.000000000 +0100
+++ color-theme-6.6.0.patched//themes/color-theme-library.el	2010-12-01 22:57:47.000000000 +0000
@@ -7052,7 +7052,7 @@
       (view-highlight-face . highlight)
       (viper-insert-state-cursor-color . "Green")
       (viper-replace-overlay-cursor-color . "Red")
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "white" :foreground "black" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "adobe-courier"))))
      (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
      (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -7469,7 +7469,7 @@
       (tags-tag-face . default)
       (vc-annotate-very-old-color . "#0046FF")
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "black" :foreground "white" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-courier new"))))
      (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
      (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -7660,7 +7660,7 @@
        (list-matching-lines-face . secondary-selection)
        (vc-annotate-very-old-color . "#0046FF")
        (view-highlight-face . highlight)
-       (widget-mouse-face . highlight))
+       (when-color-theme-is-global '(widget-mouse-face . highlight)))
       (default ((t (:stipple nil :background "#102e4e" :foreground "#eeeeee" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "misc-fixed"))))
       (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
       (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -7792,7 +7792,7 @@
       (help-highlight-face . underline)
       (list-matching-lines-face . bold)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "darkslategrey" :foreground "wheat" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-andale mono"))))
      (bbdb-field-name ((t (:foreground "green"))))
      (bg:erc-color-face0 ((t (:background "White"))))
@@ -8052,7 +8052,7 @@
       (ispell-highlight-face . highlight)
       (list-matching-lines-face . bold)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "Black" :foreground "SteelBlue" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width semi-condensed :family "misc-fixed"))))
      (bg:erc-color-face0 ((t (:background "White"))))
      (bg:erc-color-face1 ((t (:background "black"))))
@@ -8514,7 +8514,7 @@
       (semantic-which-function-use-color . t)
       (senator-eldoc-use-color . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "AliceBlue" :foreground "DarkSlateGray4" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-courier new"))))
      (bold ((t (:bold t :weight bold))))
      (bold-italic ((t (:italic t :bold t :slant italic :weight bold))))
@@ -8773,7 +8773,7 @@
       (vm-highlighted-header-face . bold)
       (vm-mime-button-face . gui-button-face)
       (vm-summary-highlight-face . bold)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "#233b5a" :foreground "#fff8dc" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-lucida console"))))
      (Info-title-1-face ((t (:bold t :weight bold :height 1.728 :family "helv"))))
      (Info-title-2-face ((t (:bold t :weight bold :height 1.44 :family "helv"))))
@@ -9466,7 +9466,7 @@
       (mouse-color . "yellow"))
      ((help-highlight-face . underline)
       (list-matching-lines-face . bold)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "black" :foreground "#00ff00" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "misc-fixed"))))
      (bold ((t (:bold t :weight bold))))
      (bold-italic ((t (:italic t :bold t :slant italic :weight bold))))
@@ -9543,7 +9543,7 @@
       (help-highlight-face . underline)
       (list-matching-lines-face . bold)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "#00457f" :foreground "white smoke" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "b&h-lucidatypewriter"))))
      (bold ((t (:bold t :foreground "snow2" :weight bold))))
      (bold-italic ((t (:italic t :bold t :slant italic :weight bold))))
@@ -9704,7 +9704,7 @@
       (semantic-which-function-use-color . t)
       (senator-eldoc-use-color . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "lightyellow2" :foreground "gray20" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-courier new"))))
      (bg:erc-color-face0 ((t (:background "White"))))
      (bg:erc-color-face1 ((t (:background "black"))))
@@ -9860,7 +9860,8 @@
       (list-matching-lines-face . bold)
       (semantic-which-function-use-color . t)
       (senator-eldoc-use-color . t)
-      (widget-mouse-face . highlight))
+      ;(widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "grey30" :foreground "gainsboro" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-courier new"))))
      (bg:erc-color-face0 ((t (:background "White"))))
      (bg:erc-color-face1 ((t (:background "black"))))
@@ -10095,7 +10096,7 @@
       (list-matching-lines-face . bold)
       (sgml-set-face . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight)
+      (when-color-theme-is-global '(widget-mouse-face . highlight))
       (x-face-mouse-face . highlight))
      (default ((t (:stipple nil :background "white" :foreground "black" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :height 116 :width normal :family "monotype-courier new"))))
      (Info-title-1-face ((t (:bold t :weight bold :height 1.728 :family "helv"))))
@@ -10488,7 +10489,7 @@
       (semantic-which-function-use-color . t)
       (senator-eldoc-use-color . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "DarkSlateGray" :foreground "palegreen" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-lucida sans typewriter"))))
      (bg:erc-color-face0 ((t (:background "White"))))
      (bg:erc-color-face1 ((t (:background "black"))))
@@ -11326,7 +11327,7 @@
       (view-highlight-face . highlight)
       (viper-insert-state-cursor-color . "Green")
       (viper-replace-overlay-cursor-color . "Red")
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "white" :foreground "black" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "adobe-courier"))))
      (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
      (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -11735,7 +11736,7 @@
       (ps-zebra-color . 0.95)
       (tags-tag-face . default)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (nil))))
      (CUA-global-mark-face ((t (:background "cyan" :foreground "black"))))
      (CUA-rectangle-face ((t (:background "maroon" :foreground "white"))))
@@ -12014,7 +12015,7 @@
       (sgml-set-face . t)
       (tags-tag-face . default)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "Grey15" :foreground "Grey" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :height 87 :width semi-condensed :family "misc-fixed"))))
      (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
      (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -12297,7 +12298,7 @@
       (rpm-spec-tag-face . rpm-spec-tag-face)
       (tags-tag-face . default)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:background "#ffffff" :foreground "#000000"))))
      (Info-title-1-face ((t (nil))))
      (Info-title-2-face ((t (nil))))
@@ -12377,7 +12378,7 @@
       (list-matching-lines-face . bold)
       (senator-eldoc-use-color . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "gray12" :foreground "green" :inverse-video nil :box nil
 :strike-through nil :overline nil :underline nil :slant normal :weight normal :height 98 :width
 normal :family "outline-courier new"))))
@@ -12544,7 +12545,7 @@
       (sgml-set-face . t)
       (tags-tag-face . default)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (nil))))
      (Buffer-menu-buffer-face ((t (:bold t :weight bold))))
      (bg:erc-color-face0 ((t (:background "White"))))
@@ -12779,7 +12780,7 @@
       (list-matching-lines-face . bold)
       (rmail-highlight-face . font-lock-function-name-face)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "black" :foreground
 "#7eff00" :inverse-video nil :box nil :strike-through nil :overline nil
 :underline nil :slant normal :weight normal :height 90 :width normal
@@ -13446,7 +13447,7 @@
      ((help-highlight-face . underline)
       (list-matching-lines-face . bold)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "ivory" :foreground "black"
 :inverse-video nil :box nil :strike-through nil :overline nil
 :underline nil :slant normal :weight normal :height 90 :width normal
diff -Naur color-theme-6.6.0/color-theme.el color-theme-6.6.0.patched//color-theme.el
--- color-theme-6.6.0/color-theme.el	2006-05-28 14:07:29.000000000 +0100
+++ color-theme-6.6.0.patched//color-theme.el	2010-12-01 23:00:32.000000000 +0000
@@ -1662,6 +1662,12 @@
 ;; define-color-theme is around, it should be easy to change in just the
 ;; one place. 
 
+(defmacro when-color-theme-is-global (prop)
+  "Return prop when color-theme-is-global is true.
+
+   Use to wrap alist settings that should not be made buffer local,
+such as widget-mouse-face and possibly others."
+  (when color-theme-is-global prop))
 
 (provide 'color-theme)
 
diff -Naur color-theme-6.6.0/themes/color-theme-library.el color-theme-6.6.0.patched//themes/color-theme-library.el
--- color-theme-6.6.0/themes/color-theme-library.el	2006-05-28 13:53:17.000000000 +0100
+++ color-theme-6.6.0.patched//themes/color-theme-library.el	2010-12-01 22:57:47.000000000 +0000
@@ -7052,7 +7052,7 @@
       (view-highlight-face . highlight)
       (viper-insert-state-cursor-color . "Green")
       (viper-replace-overlay-cursor-color . "Red")
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "white" :foreground "black" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "adobe-courier"))))
      (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
      (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -7469,7 +7469,7 @@
       (tags-tag-face . default)
       (vc-annotate-very-old-color . "#0046FF")
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "black" :foreground "white" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-courier new"))))
      (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
      (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -7660,7 +7660,7 @@
        (list-matching-lines-face . secondary-selection)
        (vc-annotate-very-old-color . "#0046FF")
        (view-highlight-face . highlight)
-       (widget-mouse-face . highlight))
+       (when-color-theme-is-global '(widget-mouse-face . highlight)))
       (default ((t (:stipple nil :background "#102e4e" :foreground "#eeeeee" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "misc-fixed"))))
       (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
       (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -7792,7 +7792,7 @@
       (help-highlight-face . underline)
       (list-matching-lines-face . bold)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "darkslategrey" :foreground "wheat" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-andale mono"))))
      (bbdb-field-name ((t (:foreground "green"))))
      (bg:erc-color-face0 ((t (:background "White"))))
@@ -8052,7 +8052,7 @@
       (ispell-highlight-face . highlight)
       (list-matching-lines-face . bold)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "Black" :foreground "SteelBlue" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width semi-condensed :family "misc-fixed"))))
      (bg:erc-color-face0 ((t (:background "White"))))
      (bg:erc-color-face1 ((t (:background "black"))))
@@ -8514,7 +8514,7 @@
       (semantic-which-function-use-color . t)
       (senator-eldoc-use-color . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "AliceBlue" :foreground "DarkSlateGray4" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-courier new"))))
      (bold ((t (:bold t :weight bold))))
      (bold-italic ((t (:italic t :bold t :slant italic :weight bold))))
@@ -8773,7 +8773,7 @@
       (vm-highlighted-header-face . bold)
       (vm-mime-button-face . gui-button-face)
       (vm-summary-highlight-face . bold)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "#233b5a" :foreground "#fff8dc" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-lucida console"))))
      (Info-title-1-face ((t (:bold t :weight bold :height 1.728 :family "helv"))))
      (Info-title-2-face ((t (:bold t :weight bold :height 1.44 :family "helv"))))
@@ -9466,7 +9466,7 @@
       (mouse-color . "yellow"))
      ((help-highlight-face . underline)
       (list-matching-lines-face . bold)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "black" :foreground "#00ff00" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "misc-fixed"))))
      (bold ((t (:bold t :weight bold))))
      (bold-italic ((t (:italic t :bold t :slant italic :weight bold))))
@@ -9543,7 +9543,7 @@
       (help-highlight-face . underline)
       (list-matching-lines-face . bold)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "#00457f" :foreground "white smoke" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "b&h-lucidatypewriter"))))
      (bold ((t (:bold t :foreground "snow2" :weight bold))))
      (bold-italic ((t (:italic t :bold t :slant italic :weight bold))))
@@ -9704,7 +9704,7 @@
       (semantic-which-function-use-color . t)
       (senator-eldoc-use-color . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "lightyellow2" :foreground "gray20" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-courier new"))))
      (bg:erc-color-face0 ((t (:background "White"))))
      (bg:erc-color-face1 ((t (:background "black"))))
@@ -9860,7 +9860,8 @@
       (list-matching-lines-face . bold)
       (semantic-which-function-use-color . t)
       (senator-eldoc-use-color . t)
-      (widget-mouse-face . highlight))
+      ;(widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "grey30" :foreground "gainsboro" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-courier new"))))
      (bg:erc-color-face0 ((t (:background "White"))))
      (bg:erc-color-face1 ((t (:background "black"))))
@@ -10095,7 +10096,7 @@
       (list-matching-lines-face . bold)
       (sgml-set-face . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight)
+      (when-color-theme-is-global '(widget-mouse-face . highlight))
       (x-face-mouse-face . highlight))
      (default ((t (:stipple nil :background "white" :foreground "black" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :height 116 :width normal :family "monotype-courier new"))))
      (Info-title-1-face ((t (:bold t :weight bold :height 1.728 :family "helv"))))
@@ -10488,7 +10489,7 @@
       (semantic-which-function-use-color . t)
       (senator-eldoc-use-color . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "DarkSlateGray" :foreground "palegreen" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "outline-lucida sans typewriter"))))
      (bg:erc-color-face0 ((t (:background "White"))))
      (bg:erc-color-face1 ((t (:background "black"))))
@@ -11326,7 +11327,7 @@
       (view-highlight-face . highlight)
       (viper-insert-state-cursor-color . "Green")
       (viper-replace-overlay-cursor-color . "Red")
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "white" :foreground "black" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :width normal :family "adobe-courier"))))
      (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
      (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -11735,7 +11736,7 @@
       (ps-zebra-color . 0.95)
       (tags-tag-face . default)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (nil))))
      (CUA-global-mark-face ((t (:background "cyan" :foreground "black"))))
      (CUA-rectangle-face ((t (:background "maroon" :foreground "white"))))
@@ -12014,7 +12015,7 @@
       (sgml-set-face . t)
       (tags-tag-face . default)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "Grey15" :foreground "Grey" :inverse-video nil :box nil :strike-through nil :overline nil :underline nil :slant normal :weight normal :height 87 :width semi-condensed :family "misc-fixed"))))
      (Info-title-1-face ((t (:bold t :weight bold :family "helv" :height 1.728))))
      (Info-title-2-face ((t (:bold t :family "helv" :weight bold :height 1.44))))
@@ -12297,7 +12298,7 @@
       (rpm-spec-tag-face . rpm-spec-tag-face)
       (tags-tag-face . default)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:background "#ffffff" :foreground "#000000"))))
      (Info-title-1-face ((t (nil))))
      (Info-title-2-face ((t (nil))))
@@ -12377,7 +12378,7 @@
       (list-matching-lines-face . bold)
       (senator-eldoc-use-color . t)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "gray12" :foreground "green" :inverse-video nil :box nil
 :strike-through nil :overline nil :underline nil :slant normal :weight normal :height 98 :width
 normal :family "outline-courier new"))))
@@ -12544,7 +12545,7 @@
       (sgml-set-face . t)
       (tags-tag-face . default)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (nil))))
      (Buffer-menu-buffer-face ((t (:bold t :weight bold))))
      (bg:erc-color-face0 ((t (:background "White"))))
@@ -12779,7 +12780,7 @@
       (list-matching-lines-face . bold)
       (rmail-highlight-face . font-lock-function-name-face)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "black" :foreground
 "#7eff00" :inverse-video nil :box nil :strike-through nil :overline nil
 :underline nil :slant normal :weight normal :height 90 :width normal
@@ -13446,7 +13447,7 @@
      ((help-highlight-face . underline)
       (list-matching-lines-face . bold)
       (view-highlight-face . highlight)
-      (widget-mouse-face . highlight))
+      (when-color-theme-is-global '(widget-mouse-face . highlight)))
      (default ((t (:stipple nil :background "ivory" :foreground "black"
 :inverse-video nil :box nil :strike-through nil :overline nil
 :underline nil :slant normal :weight normal :height 90 :width normal